<?php
/* * ********************************************************************
*  ProxmoxVPS Product developed. (27.03.19)
* *
*
*  CREATED BY MODULESGARDEN       ->       http://modulesgarden.com
*  CONTACT                        ->       contact@modulesgarden.com
*
*
* This software is furnished under a license and may be used and copied
* only  in  accordance  with  the  terms  of such  license and with the
* inclusion of the above copyright notice.  This software  or any other
* copies thereof may not be provided or otherwise made available to any
* other person.  No title to and  ownership of the  software is  hereby
* transferred.
*
*
* ******************************************************************** */

namespace ModulesGarden\Servers\ProxmoxCloudVps\App\UI\Disk\Forms;

use ModulesGarden\ProxmoxAddon\App\Services\Cloud\ProductService;
use ModulesGarden\ProxmoxAddon\App\Services\Cloud\ResourceManager;
use ModulesGarden\Servers\ProxmoxCloudVps\App\UI\Disk\Providers\DiskProvider;
use ModulesGarden\Servers\ProxmoxCloudVps\App\UI\Validators\NumberValidator;
use ModulesGarden\Servers\ProxmoxCloudVps\Core\UI\Interfaces\ClientArea;
use ModulesGarden\Servers\ProxmoxCloudVps\Core\UI\Widget\Forms\BaseForm;
use ModulesGarden\Servers\ProxmoxCloudVps\Core\UI\Widget\Forms\Fields\Range;
use ModulesGarden\Servers\ProxmoxCloudVps\Core\UI\Widget\Forms\Fields\Select;
use ModulesGarden\Servers\ProxmoxCloudVps\Core\UI\Widget\Forms\Fields\Switcher;
use ModulesGarden\Servers\ProxmoxCloudVps\Core\UI\Widget\Forms\Fields\Text;
use ModulesGarden\Servers\ProxmoxCloudVps\App\UI\VmCreate\Validators\DiskSizeValidator;
use function ModulesGarden\Servers\ProxmoxCloudVps\Core\Helper\sl;


class CreateForm extends BaseForm implements ClientArea
{
    use ProductService;

    public function initContent()
    {
        $this->initIds('createDiskForm');
        $this->setFormType('create');
        $this->setProvider(new DiskProvider());
        $this->initFields();
        $this->loadDataToForm();
    }

    public function getAllowedActions()
    {
        return ['create'];
    }

    private function initFields()
    {
        //size
        $this->resourceManager = new ResourceManager();
        $field = new Range('additionalDiskSize', $this->configuration()->serverDiskSize->min, $this->resourceManager->disk()->free());
        $field->addValidator(new DiskSizeValidator('additionalDiskSize',true));
        $field->setDefaultValue($this->configuration()->serverDiskSize->min);
//        $field->setDescription('description');
        $this->addField($field);
        //bus
        $field = new Select('bus');
        $options=[];
        foreach( $this->configuration()->getAdditionalDiskType() as $entery){
            $options[$entery] = sl("lang")->abtr($entery);
        }
        $field->setAvailableValues($options);
        if(count($this->configuration()->getAdditionalDiskType()) == 1) {
            $field->setSelectedValue($this->configuration()->getAdditionalDiskType()[0]);
            $field->addClass('hidden');
        }
        $this->addField($field);
        //format
        $field = new Select('format');
        $options=[];
        foreach( $this->configuration()->getAdditionalDiskFormat() as $entery){
            $options[$entery] = sl("lang")->abtr($entery);
        }
        $field->setAvailableValues($options);
        if(count($this->configuration()->getAdditionalDiskFormat()) == 1){
            $field->setSelectedValue($this->configuration()->getAdditionalDiskFormat()[0]);
            $field->addClass('hidden');
        }
        $this->addField($field);
        //backup
        if ($this->configuration()->isPermissionAdditionalDiskBackup())
        {
            $field = new Switcher('backup');
            $this->addField($field);
        }

    }
}